#ifndef DISTANCE_FIELD
#define DISTANCE_FIELD

#include "geometries.fx"
#include "modifiers.fx"
#include "materials.fx"

float2 bigSpherePower <string uiname="Power (Big Sphere)";> = 2;
float2 bsradius <string uiname="Radius (Big Sphere)";> = 10;
float3 bspos <string uiname="Position (Big Sphere)";> = {0, 40, 0};
const int crateramount <string uiname="Amount of craters (Big Sphere)";> = 4;
float craterphase <string uiname="Phase of craters (Big Sphere)";> = 0;
float craterradius <string uiname="Radius of craters (Big Sphere)";> = 4;
float roomsize <string uiname="Repeat Size";> = 15;
float boxfreq <string uiname="Wave frequency (Boxes)";> = 2;
float boxPhase <string uiname="Wave phase (Boxes)";> = 0;
float boxradius <string uiname="Corner Radius (Boxes)";> = 0.2;

float distanceField ( float3 p, out int materialID )
{
	// write your scene here there's a very basic example below but feel free to completely replace it

	// "dist" will contain our current distance and this will be returned. rename it if you want
	float dist = 0;
	// apply modifiers to RayPosition ("p") before the desired geometry
	float3 prep = p;
	p = Transform(p, tV);

	// infinite ground
	// it's worth to set a ground so the shader won't march to max distance on majority of the screen
	// TODO: write some occlusion culling stuff
	dist = p.y+2;
	materialID = MATERIAL_FLOOR;

	// define a sphere in the center
	float tempDist = sdTorus(p, bspos, bsradius, bigSpherePower);
	// temporary variable for retrieving structure from the Union ("oU") operation
	opdata temp = (opdata)0;
	temp = oU(dist, materialID, tempDist, MATERIAL_SPHERE);
	dist = temp.distance;
	materialID = temp.material;

	// carving in some craters in the big sphere
	float tempDist2 = maxDist;
	float3 spos = bspos;
	float rr = (craterphase)*PI2;
	spos.x = cos(rr) * bsradius.x;
	spos.z = sin(rr) * bsradius.x;
	tempDist = sdSphereC(p, spos, craterradius, 2).distance;
	rr = (.5 + craterphase)*PI2;
	spos.x = cos(rr) * bsradius.x;
	spos.z = sin(rr) * bsradius.x;
	tempDist2 = sdSphereC(p, spos, craterradius, 2).distance;
	float sphGroup = oU(tempDist, materialID, tempDist2, materialID).distance;
	
	dist = oS(dist, materialID, sphGroup, materialID).distance; // we don't care about materials here it'll be the same as the big sphere
	// a little hack :P
	float3 pprep = Repeat(prep, roomsize, bool3(1,0,1));
	p = Transform(pprep, tV);

	// place some "valleys" here (modulate box sizes by position)
	float3 boxSize = 9;
	boxSize.y = 4.5 + 4 * sin((prep.x * boxfreq) * PI2 * 0.2+ boxPhase*PI2);
	tempDist = udRoundBox(p, float3(0, boxSize.y-3, 0), boxSize, boxradius);
	temp = oU(dist, materialID, tempDist, MATERIAL_BOX);
	dist = temp.distance;
	materialID = temp.material;

	return dist;
}

#endif // DISTANCE_FIELD